/**
* fifo.h - FIFO queue data structure
*
* Copyright (C) 2004-2005 Pantelis Frangoudis, Elias Efstathiou
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef _FIFO_H
#define _FIFO_H

#include <stdio.h>

//FIFO QUEUE
//implemented as a doubly-linked list
typedef struct fifo_queue_node_t {
	void *data;
	struct fifo_queue_node_t *next;
	struct fifo_queue_node_t *prev;
} FIFO_NODE;

void fifo_push(FIFO_NODE *to_be_enqueued, FIFO_NODE **fhead, FIFO_NODE **ftail);
FIFO_NODE *fifo_pop(FIFO_NODE **fhead, FIFO_NODE **ftail);
void fifo_empty(FIFO_NODE **fhead, FIFO_NODE **ftail);

#endif /* _FIFO_H */
