/**
* storage.h - Receipt storage routines
*
* Copyright (C) 2004-2005 Pantelis Frangoudis, Elias Efstathiou
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef STORAGE_H
#define STORAGE_H

#include "io.h"

#define FL_ERROR -1
#define FL_EMPTY_FILE -2

long pop_free_pos(const char *receipts_db_free_list);
int push_free_pos(const char *receipts_db_free_list, long free_pos, long max_receipts);
long *get_free_list(const char *receipts_db_free_list, int *num_of_items);
int is_free_pos(long *free_list, int list_len, long pos);

#endif /* STORAGE_H */
